=== debian/changelog ===
bcftools (1.2-2) unstable; urgency=medium

  * Fix autopkgtest dependencies
  * Declare conflict with older versions of samtools (Closes: #812328)

 -- Afif Elghraoui <afif@ghraoui.name>  Fri, 22 Jan 2016 18:52:53 -0800

bcftools (1.2-1) unstable; urgency=low

  * Initial release (Closes: #804007)

 -- Afif Elghraoui <afif@ghraoui.name>  Mon, 09 Nov 2015 23:44:39 -0800
