=== debian/control ===
Source: bcftools
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
	Afif Elghraoui <afif@ghraoui.name>
Build-Depends:
	debhelper (>= 9),
	zlib1g-dev,
	libhts-dev (>= 1.2.1),
	libgsl-dev,
# Test-Depends:
	tabix,
	libio-pty-perl
Standards-Version: 3.9.6
Homepage: http://samtools.github.io/bcftools/
Vcs-Git: git://anonscm.debian.org/debian-med/bcftools.git
Vcs-Browser: http://anonscm.debian.org/cgit/debian-med/bcftools.git

Package: bcftools
Architecture: any
Breaks: samtools (<< 1.0)
Replaces: samtools (<< 1.0)
Depends:
	${shlibs:Depends},
	${misc:Depends},
	${perl:Depends}
Suggests:
# These are needed for plot-vcfstats
	python,
	python-numpy,
	python-matplotlib,
	texlive-latex-recommended
Description: genomic variant calling and manipulation of VCF/BCF files
 BCFtools is a set of utilities that manipulate variant calls in the
 Variant Call Format (VCF) and its binary counterpart BCF. All commands work
 transparently with both VCFs and BCFs, both uncompressed and BGZF-compressed.
