=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

CFLAGS := $(CPPFLAGS) $(CFLAGS)

export HTSDIR=/usr/include
export USE_GPL=1
export pluginpath=/usr/lib/$(DEB_HOST_MULTIARCH)/bcftools

%:
	dh $@ --parallel

override_dh_auto_install:
	mkdir -p debian/bcftools/$(pluginpath)
	mv plugins/*.so \
	   debian/bcftools/$(pluginpath)
	dh_auto_install

override_dh_installman:
	dh_installman --language=C
