=== debian/tests/control ===
Tests: runtests
Depends:
	@,
	tabix,
	perl,
	build-essential,
Restrictions:
	allow-stderr,
	rw-build-tree,
