=== debian/changelog ===
bcftools (1.3.1-1~bpo8+2) jessie-backports; urgency=medium

  * Rebuild against libgsl-dev 2.3 which is now in Jessie backports

 -- Andreas Tille <tille@debian.org>  Fri, 17 Mar 2017 15:19:52 +0100

bcftools (1.3.1-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Afif Elghraoui <afif@debian.org>  Wed, 11 May 2016 20:10:13 -0700

bcftools (1.3.1-1) unstable; urgency=medium

  * Imported Upstream version 1.3.1
  * Remove backported patches
  * Refresh remaining patches
  * Bump htslib minimum dependency
  * Bump Standards-Version to 3.9.8
  * Add a manpage for the color-chrs command

 -- Afif Elghraoui <afif@debian.org>  Mon, 25 Apr 2016 22:24:50 -0700

bcftools (1.3-3) unstable; urgency=medium

  * Backport upstream patch to fix build on arm64, armel, and ppc64el
    (Closes: #812268)

 -- Afif Elghraoui <afif@debian.org>  Thu, 31 Mar 2016 00:57:18 -0700

bcftools (1.3-2) unstable; urgency=medium

  * Backport upstream patch to be able to build plugin with GSL2
  * Bump Standards-Version
  * Use encrypted protocols for VCS URLs

 -- Afif Elghraoui <afif@ghraoui.name>  Sun, 21 Feb 2016 16:35:44 -0800

bcftools (1.3-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Re-enable building with GSL since there is no API problem here.

 -- Afif Elghraoui <afif@ghraoui.name>  Tue, 09 Feb 2016 22:12:24 -0800

bcftools (1.3-1) unstable; urgency=medium

  * New upstream release (Closes: #813465)
  * Disable building with libgsl until build issue with GSL2 is addressed
  * Update d/TODO to indicate GSL issue forwarded
  * Simplify d/rules as a result of improvements to build system
  * Update htslib minimum dependency
  * Add libhts-dev dependency for CI tests

 -- Afif Elghraoui <afif@ghraoui.name>  Wed, 03 Feb 2016 23:44:03 -0800

bcftools (1.2-2~bpo8+1) jessie-backports; urgency=medium

  * Adjust libgsl dependency for Stable.
  * Rebuild for jessie-backports.

 -- Afif Elghraoui <afif@ghraoui.name>  Thu, 28 Jan 2016 23:02:03 -0800
