=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1
#include /usr/share/dpkg/default.mk

export HTSDIR=/usr/include
export USE_GPL=1
export plugindir=/usr/lib/$(DEB_HOST_MULTIARCH)/bcftools

%:
	dh $@ --parallel

override_dh_installman:
	dh_installman --language=C
