=== debian/changelog ===
bcftools (1.4.1-3build1) artful; urgency=medium

  * No-change rebuild for libgsl soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 06 Aug 2017 00:08:14 +0000

bcftools (1.4.1-3) unstable; urgency=medium

  * Team upload.
  * Incorporate patches from Ubuntu to fix FTBFS on some 32-bit archs.
  * Fix autopkgtests by ensuring presence of all deps.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 29 Jul 2017 10:38:27 +0200

bcftools (1.4.1-2) unstable; urgency=medium

  * Team upload
  * Fix FTBFS on architectures where char is unsigned by default,
    thanks Adrian Bunk (Closes: #865060)

 -- Graham Inggs <ginggs@debian.org>  Wed, 19 Jul 2017 11:00:08 +0200

bcftools (1.4.1-1) unstable; urgency=medium

  * Team upload
  * New upstream version
    Closes: #865006
  * debhelper 10

 -- Andreas Tille <tille@debian.org>  Sun, 18 Jun 2017 21:41:36 +0200
