=== debian/control ===
--- 
+++ 
@@ -3,19 +3,19 @@
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders:
-	Afif Elghraoui <afif@ghraoui.name>
+	Afif Elghraoui <afif@debian.org>
 Build-Depends:
-	debhelper (>= 9),
+	debhelper (>= 10),
 	zlib1g-dev,
-	libhts-dev (>= 1.2.1),
+	libhts-dev (>= 1.3.1),
 	libgsl-dev,
 # Test-Depends:
 	tabix,
 	libio-pty-perl
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://samtools.github.io/bcftools/
-Vcs-Git: git://anonscm.debian.org/debian-med/bcftools.git
-Vcs-Browser: http://anonscm.debian.org/cgit/debian-med/bcftools.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/bcftools.git
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bcftools.git
 
 Package: bcftools
 Architecture: any
