=== debian/tests/control ===
Tests: runtests
Depends:
	@,
	tabix,
	perl,
        @builddeps@
Restrictions:
	allow-stderr,
	rw-build-tree,
